:: taz-3-9-config-restore.bat
:: Wiederherstellung der Einstellungen der TransAlarm-Zentrale (3.9.x)
:: Version 4, 2021-07-15, peu
@echo off

:: Pruefen, ob Administratorrechte gegeben sind
fsutil dirty query %systemdrive% >nul

:: Bei errorlevel <> 0 ist das nicht der Fall:
if '%errorlevel%' NEQ '0' (
    echo Requesting administrative privileges...
    goto UACPrompt
) else ( goto gotAdmin )

:: Massnahme, um Rechte im interaktiven Benutzer-Dialog zu erwerben.
:: Es wird ein VisualBasic-Skript erzeugt, das das vorliegende Skript
:: nochmals als Administrator ausfuehrt:
:UACPrompt
    echo Set UAC = CreateObject^("Shell.Application"^) > "%temp%\getadmin.vbs"
    echo args = "" >> "%temp%\getadmin.vbs"
    echo For Each strArg in WScript.Arguments >> "%temp%\getadmin.vbs"
    echo args = args ^& strArg ^& " "  >> "%temp%\getadmin.vbs"
    echo Next >> "%temp%\getadmin.vbs"
    echo UAC.ShellExecute "%0", args, "", "runas", 1 >> "%temp%\getadmin.vbs"

    call "%temp%\getadmin.vbs" %*
    del "%temp%\getadmin.vbs"
    exit /B

:gotAdmin
    echo Adminrechte liegen vor
    pushd "%~dp0"
::--------------------------------------
setlocal

if "%1"=="" (
echo Sie haben keine Konfiguration ^(Zip-Archiv^) angegeben! 
echo.
pause 
goto end
)
echo Stand "%1" wiederherstellen.
set archiv="%1"

set "appInfix="

:: Windows-Version ermitteln:
for /f "tokens=4-5 delims=.XP " %%i in ('ver') do set VERSION=%%i.%%j
if "%version%" == "10.0" echo Windows 10 && goto bits
if "%version%" == "6.3" echo Windows 8.1 && goto bits
if "%version%" == "6.2" echo Windows 8. && goto bits
if "%version%" == "6.1" echo Windows 7. && goto bits
if "%version%" == "6.0" echo Windows Vista. && goto bits
if "%version%" == "5.1" (
echo Windows XP.
:: bei Windows XP (de) liegen die Anwendungsdaten in einem Unterordner
set "appInfix=\Anwendungsdaten"
goto bits
)

:: Problem:
echo FEHLER. Unbekannt: Version %version%
echo Analyse wird abgebrochen.
goto end

:bits

:: Bittigkeit ermitteln:
reg query "HKLM\Hardware\Description\System\CentralProcessor\0" | find /i "x86" > NUL && set OS=32BIT || set OS=64BIT
if %OS%==32BIT echo 32bit OS && set "prog32=%programfiles%" && goto bits_done
if %OS%==64BIT echo 64bit OS && set "prog32=%programfiles(x86)%" && goto bits_done

:: Problem:
echo FEHLER. Interner Fehler bei Analyse der Bittigkeit (x86, x64)
echo Analyse wird abgebrochen.
goto end

:bits_done

:: ?? set _TMP_TAZBAK=%TMP%\TAZBAK
set _TMP_TAZBAK=%TMP%\TAZBAK

:: create temp folders
mkdir %_TMP_TAZBAK%

:: Archiv entpacken
.\7-zip\7za x %archiv% -o%_TMP_TAZBAK%

set "reg32opt="
:: bei 64-bit-Systemen liegen 32-bit-Anwendungen auf speziellem Zweig
if %OS%==64BIT set "reg32opt=/reg:32"

echo reg32opt: "%reg32opt%"

reg query HKLM\Software\REKOBA /reg:32 >NUL 2>&1
if %errorlevel% neq 0 goto registry
echo Reg-Key existiert bereits.
SET AREYOUSURE=N
SET /P AREYOUSURE=Wollen Sie ggf. Werte ueberschreiben (J/[N])?
IF /I "%AREYOUSURE%" NEQ "J" echo (uebersprungen) && GOTO done_registry

:registry

:: restore REKOBA TransAlarm registry key
reg import %_TMP_TAZBAK%\Registry\HKLM-REKOBA.reg.txt %reg32opt% >NUL 2>&1

:done_registry

echo prog32: "%prog32%"

set "profName=REKOBA\TransAlarm"

set "tazprofile=%allusersprofile%%appInfix%\%profName%"
echo tazprofile: "%tazprofile%"

if not exist "%tazprofile%\Config\" goto profile
echo Config im Profilordner ("%tazprofile%\Config\") existiert bereits.
SET AREYOUSURE=N
SET /P AREYOUSURE=Wollen Sie ggf. Werte ueberschreiben (J/[N])?
IF /I "%AREYOUSURE%" NEQ "J" echo (uebersprungen) && GOTO done_profile

:profile

:: copy config files to "profile folder" (machine)
xcopy %_TMP_TAZBAK%\AllUsersProfile\REKOBA\TransAlarm\Config "%tazprofile%\Config\*" /S /I /Y /Q

:done_profile

:: Temporaeren Ordner loeschen:
rmdir %_TMP_TAZBAK% /s /q

:: Fertig mit dem Restaurieren:
echo.
echo Fertig.
echo.

:end

endlocal
